<script setup>
import { date } from 'alga-js'
const router = useRouter()

definePageMeta({
  middleware: ['auth', 'org']
})

const form = ref({
  id: '',
  client: '',
  clientId: '',
  organization: '',
  organizationId: '',
  name: '',
  description: '',
  isActive: true,
  isNaturalAccount: false,
  isBalancing: false,
  vFormat: '',
  elementType: 'Account',
  elementTypeId: 'A',
  tree: 'GardenWorld ElementValue (Account, etc.)',
  treeId: 101,
  processing: false,
  alert: {
    status: '',
    message: ''
  }
})

const back = () => {
  router.push('/accountings/elements')
}

const save = async (record, id = '', saveType = '') => {
  const res = await $fetch('/api/accountings/elements/store', {
    method: 'POST',
    headers: useRequestHeaders(['cookie']),
    body: {
      organizationId: record.organizationId,
      name: record.name,
      description: record.description,
      isActive: record.isActive,
      isNaturalAccount: record.isNaturalAccount,
      isBalancing: record.isBalancing,
      vFormat: record.vFormat,
      elementTypeId: record.elementTypeId,
      treeId: record.treeId,
    }
  })

  if(Number(res.status) === 200) {
    if(saveType === 'preview') {
      router.push('/accountings/elements/'+res.id+'/view')
    } else if(saveType === 'changes') {
      router.push('/accountings/elements/'+res.id+'/edit')
    } else {
      back()
    }
  } else {
    form.value.alert.status = res.status
    form.value.alert.message = res.message
    form.value.processing = false
    window.scrollTo(0, 0)
  }
}

const breadCrumb = computed(() => ([
  { link: '/accountings/elements', text: 'Chart of Accounts'},
  { link: '#', text: 'Add Chart of Account', active: true}
]))
</script>

<template>
  <Head>
    <Title>Add Chart of Account</Title>
  </Head>

  <NuxtLayout name="new-dash">
    <NewBreadCrumb :items="breadCrumb" />
    <div>
      <div class="banner">
        <div class="d-flex justify-between mb-3">
          <h4></h4>
          <div class="d-flex gap-0.75rem">
            <button type="button" @click="back" class="button">
              <span class="tf-icon ti ti-chevron-left ti-xs me-1"></span> Back
            </button>
          </div>
        </div>
        <div>
          <AccountingsElementForm v-model="form" @save="save"/>
        </div>
      </div>

    </div>
  </NuxtLayout>
</template>